#ifndef _CAMMENU
#define _CAMMENU

/* ************************************************************************** */
/* Includes definitions                                                       */
/* ************************************************************************** */
//#define __mdebug printf("%s:%d\n", __FILE__, __LINE__)
#include <cstdio>					// fgets, fopen, perror, printf, sprintf
#include <string>					// string class
#include <vector>					// vector class
#include "./libUtilsVar.h"		// Utils library (uses util::format)
#include <cv.h>					// includes OpenCV definitions
#include <highgui.h>				// includes highGUI definitions
#include "menuTreeGUI.h"		// class that represents graphically menu tree

class CamMenu
{
private:
	cv::Size imgSize;										/** Tamaño de la imagen a mostrar */
	static const int _MENULEFTWIDTH = 100;			/** Tamaño por defecto del menu lateral */
	static const int _MENUBOTTOMHEIGHT = 35;		/** Tamaño por defecto de menu inferior */
	int numCamera;											/** Numero de camara a abrir */
	cv::VideoCapture streamCapture;					/** flujo de captura de la camara */
	cv::Mat camMenuImg;									/** imagen que contiene la imagen de la camara y el menu de usuario */
	cv::Mat frame;											/** Imagen capturada de la camara (no se debe procesar directamente) */
	MenuTreeGUI menutreegui;							/** Clase que muestra un menu grafico al usuario */
	std::vector <std::string > text;					/** texto a mostrar al usuario en el menu inferior */
	char key;												/** tecla pulsada por el usuario */
	int salir;												/** true cuando se pulse salir en el menu */
	std::string espacioDeColor;						/** Muestra el espacio de color indicado (RGB, R, G, B, HSV, H, S, V */
	int modoMedicion;										/** true si esta activo el modo medicion de objetos */
	int modoDistorsion;									/** true si se esta en modo distorsion de lente */
	int ajusteLuz;											/** Determina el ajuste de luz a aplicar a la imagen */
	std::vector <cv::Point> tamObjeto;				/** Almacena los puntos de inicio y fin del objeto a medir en el modo medicion */
	
public:	
	cv::Mat camImg;											/** imagen capturada de la camara */
	
	CamMenu();

	int openCamera(int ncam = 0);
	
	int update(int wait = 50);
	
	int Exit();
	
private:
	void initMenu();
	
	void applyOptionsToImage();
	
	void readAnExeUserInput();
	
	void setBottomMenuMessage();
};

#endif
